
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JMeter入门(4)：Java Request实例 / 憋错料</title>

    <meta name="description" content="JMeter入门(4)：Java Request实例 目的:对Java程序进行测试: 一.核心步骤 1.创建一个Java工程: 2.将JMeter的lib目录下的jar文件添加进此工程的Build Path: 3.创建一个类并实现JavaSamplerClient接口或继承AbstractJavaSamplerClient,并重写: public Arguments getDefaultParameters():设置可用参数及的默认值: public void setupTest(JavaSamplerContext arg0):每个线程测试前执行">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">JMeter入门(4)：Java Request实例</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>目的：对<a><strong>Java</strong></a>程序进行<a><strong>测试</strong></a>；</p>
<p>　　<strong>一、核心步骤</strong></p>
<p>　　1.创建一个Java工程；</p>
<p>　　2.将<a><strong>JMeter</strong></a>的lib目录下的jar文件添加进此工程的Build Path；</p>
<p>　　3.创建一个类并实现JavaSamplerClient接口或继承AbstractJavaSamplerClient，并重写：</p>
<table>
<tbody>
<tr>
<td>
<br />public Arguments getDefaultParameters()：设置可用参数及的默认值；</p>
<p>public void setupTest(JavaSamplerContext arg0)：每个线程测试前执行一次，做一些初始化<a><strong>工作</strong></a>；</p>
<p>public SampleResult runTest(JavaSamplerContext arg0)：开始测试，从arg0参数可以获得参数值；</p>
<p>public void teardownTest(JavaSamplerContext arg0)：测试结束时调用；</p>
<p>4.Export为Runnable Jar File；
</td>
</tr>
</tbody>
</table>
<p>　　5.将此jar包放入JMETER_HOME\lib\ext目录；</p>
<p>　　6.以管理员身份打开JMeter；</p>
<p>　　7.创建线程组、Java Request、结果树，进行测试；</p>
<p>　　<strong>二、实例</strong></p>
<p>　　利用JMeter对服务进行<a><strong>性能测试</strong></a>，服务为：将输入的两个参数通过IO存入文件；</p>
<p>　　1、编写Java代码</p>
<p>　　服务：</p>
<table>
<tbody>
<tr>
<td>
<br />package <a><strong>test</strong></a>;</p>
<p>import java.io.File;</p>
<p>import java.io.PrintWriter;</p>
<p>public class OutputService {</p>
<p>public static void output(String filename,int a, int b) throws Exception {</p>
<p>PrintWriter out = new PrintWriter(new File(filename));</p>
<p>out.write(a+":"+b);</p>
<p>out.close();</p>
<p>}</p>
<p>}
</td>
</tr>
</tbody>
</table>
<p>　　测试类：(见最后的测试类)</p>


<p><strong>2、设置JMeter</strong></p>
<p>　　以管理员身份打开JMeter，并创建Java Request后,结构如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTFES1VnLmpwZw==.jpg" /></p>
<p>　　在Java请求中发现了自己新建的测试类：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTJBYVpoLmpwZw==.jpg" /></p>
<p>　　我们在JMeter中发现参数有三个：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTNteTRjLmpwZw==.jpg" /></p>
<p>　　我们在响应的数值中填入：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTRTUTBlLmpwZw==.jpg" /></p>
<p>　　大家一定很奇怪，怎么会有一些看不懂的东西，这是JMeter提供的函数，我们可以在<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTVjYUtVLmpwZw==.jpg" /></p>
<p>　　因为我们要做的是性能测试，因此我们需要开多个线程并发测试，因此随机数很重要；</p>
<p>　　常用的函数为：</p>
<p>　　(1)_Random生成随机整数；</p>
<p>　　(2)_RandomString生成随机字符串；</p>
<p>　　在线程组中设置并发线程数为10000，保存后即可运行；</p>
<p>　　图形结果如下所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTZOODNhLmpwZw==.jpg" /></p>
<p>聚合报告：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTdzaFA1LnRodW1iLmpwZw==.jpg" /></p>
<p>　　表格查看结果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMThRMWZxLmpwZw==.jpg" /></p>
<p>　　结果成功，成功生成了接近10000个文件：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTlpNDB0LmpwZw==.jpg" /></p>
<p>　　3.期间遇到的问题</p>
<p>　　3.1 Export为Jar File导致Java Request的类名称无法找到；</p>
<p>　　3.2 JMeter java.lang.OutOfMemoryError: PermGen space问题：</p>
<p>　　在JMeter.bat 中修改：</p>
<p>　　set HEAP=-Xms512m -Xmx1024m</p>
<p>　　set NEW=-XX:NewSize=128m -XX:MaxNewSize=128m</p>
<p>　　set SURVIVOR=-XX:SurvivorRatio=8 -XX:TargetSurvivorRatio=50%</p>
<p>　　set TENURING=-XX:MaxTenuringThreshold=2</p>
<p>　　set RMIGC=-Dsun.rmi.dgc.client.gcInterval=600000 -Dsun.rmi.dgc.server.gcInterval=600000</p>
<p>　　set PERM=-XX:PermSize=256m -XX:MaxPermSize=512m</p>
<p>　　3.3 JMeter需要以管理员身份打开，否则会出现：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LjUxdGVzdGluZy5jb20vYXR0YWNobWVudHMvMjAxMy8xMS8xNDk4MjY3Ml8yMDEzMTExMjE4NTYxMTEwMWZxdi5qcGc=.jpg" /></p>
<table>
<tbody>
<tr>
<td>
<br />package test;</p>
<p>import org.apache.jmeter.config.Arguments;</p>
<p>import org.apache.jmeter.protocol.java.sampler.JavaSamplerClient;</p>
<p>import org.apache.jmeter.protocol.java.sampler.JavaSamplerContext;</p>
<p>import org.apache.jmeter.samplers.SampleResult;</p>
<p>public class PerformenceTest implements JavaSamplerClient {</p>
<p>private SampleResult results;</p>
<p>private String a;</p>
<p>private String b;</p>
<p>private String filename;</p>
<p>// 设置传入的参数，可以设置多个，已设置的参数会显示到Jmeter的参数列表中</p>
<p>public Arguments getDefaultParameters() {</p>
<p>Arguments params = new Arguments();</p>
<p>params.addArgument("filename", "0");//设置参数，并赋予默认值0</p>
<p>params.addArgument("a", "0");//设置参数，并赋予默认值0</p>
<p>params.addArgument("b", "0");//设置参数，并赋予默认值0</p>
<p>return params;</p>
<p>}</p>
<p>// 初始化方法，实际运行时每个线程仅执行一次，在测试方法运行前执行</p>
<p>public void setupTest(JavaSamplerContext arg0) {</p>
<p>results = new SampleResult();</p>
<p>}</p>
<p>// 测试执行的循环体，根据线程数和循环次数的不同可执行多次</p>
<p>@Override</p>
<p>public SampleResult runTest(JavaSamplerContext arg0) {</p>
<p>b = arg0.getParameter("b"); // 获取在Jmeter中设置的参数值</p>
<p>a = arg0.getParameter("a"); // 获取在Jmeter中设置的参数值</p>
<p>filename = arg0.getParameter("filename"); // 获取在Jmeter中设置的参数值</p>
<p>results.sampleStart();// jmeter 开始统计响应时间标记</p>
<p>try {</p>
<p>OutputService test = new OutputService();</p>
<p>test.output(filename,Integer.parseInt(a), Integer.parseInt(b));</p>
<p>results.setSuccessful(true);</p>
<p>// 被测对象调用</p>
<p>} catch (Throwable e) {</p>
<p>results.setSuccessful(false);</p>
<p>e.printStackTrace();</p>
<p>} finally {</p>
<p>results.sampleEnd();// jmeter 结束统计响应时间标记</p>
<p>}</p>
<p>return results;</p>
<p>}</p>
<p>// 结束方法，实际运行时每个线程仅执行一次，在测试方法运行结束后执行</p>
<p>public void teardownTest(JavaSamplerContext arg0) {</p>
<p>}</p>
<p>public static void main(String[] args) {</p>
<p>// TODO Auto-generated method stub</p>
<p>Arguments params = new Arguments();</p>
<p>params.addArgument("a", "0");//设置参数，并赋予默认值0</p>
<p>params.addArgument("b", "0");//设置参数，并赋予默认值0</p>
<p>JavaSamplerContext arg0 = new JavaSamplerContext(params);</p>
<p>PerformenceTest test = new PerformenceTest();</p>
<p>test.setupTest(arg0);</p>
<p>test.runTest(arg0);</p>
<p>test.teardownTest(arg0);</p>
<p>}</p>
<p>}</p>
<p>Export 为 Runnable Jar File；
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 09:20:10 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>JMeter入门(4)：Java Request实例的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NddN60.html" rel="bookmark">Thrift入门及Java实例演示&amp;lt&semi;转载备用&amp;gt&semi;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Thrift入门及Java实例演示 作者: Michael 日期: 2012 年 6 月 14 日 •概述 •下载配置 •基本概念 1.数据类型 2.服务端编码基本步骤 3.客户端编码基本步骤 4.数据传输协议 •实例演示(java) 1. thrift生成代码 2. 实现接口Iface 3.TSimpleServer服务模型 4.TThreadPoolServer 服务模型 5.TNonblockingServer 服务模型 6.THsHaServer服务模型 7.异步客户端 [一].概述 T			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41o2OP0.html" rel="bookmark">Spring MVC注解配置结合Hibernate的入门教程及其代码实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Spring MVC注解配置结合Hibernate的入门教程及其代码实例 源代码下载地址:http://www.zuidaima.com/share/1787210045197312.htm 1.概述 本文旨在搭建Spring MVC+Hibernate开发框架,通过一个简单的demo讲解Spring MVC的相关配置文件,以及通过注解方式实现简单功能. 开发框架:Spring+Spring MVC+Hibernate(Spring所用的版本为3.0.5). 数据库:MySQL(数据库名称			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J2RmP4.html" rel="bookmark">【转】JMeter入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.JMeter概述 JMeter就是一个测试工具,相比于LoadRunner等测试工具,此工具免费,且比较好用,但是前提当然是安装Java环境: JMeter可以做 (1)压力测试及性能测试: (2)数据库测试: (3)Java程序的测试: (4)HTTP及FTP测试: (5)Web Service测试: 等等: 和JMeter一起使用的可能是JDK自带的测试工具JConsole,位于JDK\bin\JConsole,此工具主要观察堆.JVM.CPU的使用情况,界面如下: 二.JMeter安装			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e8ypbM.html" rel="bookmark">webservice的Axis2入门教程java版</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转自百度文库 Axis2是一套崭新的WebService引擎,该版本是对Axis1.x重新设计的产物.Axis2不仅支持SOAP1.1和SOAP1.2,还集成了非常流行的REST WebService,同时还支持Spring.JSON等技术.这些都将在后面的系列教程中讲解.在本文中主要介绍了如何使用Axis2开发一个不需要任何配置文件的WebService,并在客户端使用Java和C#调用这个WebService. 一.Axis2的下载和安装 读者可以从如下的网址下载Axis2的最新版本:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J86ol0.html" rel="bookmark">JMeter入门教程2：录制1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				介绍录制功能开始前,大家有没有想过为什么要录制?原因无非是以下几种: 1.不会写代码 2.场景过于庞大 3.节约时间 其实大家能想到的,Apache都帮大家想到了.对于Jmeter而言,提供给大家非常多的可视化图形组件,帮助大家轻而易举地编辑脚本,并且最关键的是能够简单地把操作录制下来,同时录制功能非常的智能.这个我们在后面会慢慢介绍. 开始介绍录制之前聊一下我的体会,因为大家百度会发现不少关于jmeter录制功能的文章.而这些文章大部分还停留在原始社会即使用badboy进行录制.badboy是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38yLNn4.html" rel="bookmark">RPC学习----Thrift快速入门和Java简单示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.什么是RPC? RPC(Remote Procedure Call Protocol)——远程过程调用协议,它是一种通过网络从远程计算机程序上请求服务,而不需要了解底层网络技术的协议. RPC协议假定某些传输协议的存在,如TCP或UDP,为通信程序之间携带信息数据.在OSI网络通信模型中,RPC跨越了传输层和应用层.RPC使得开发包括网络分布式多程序在内的应用程序更加容易. 二.什么是Thrift? thrift是一个软件框架,用来进行可扩展且跨语言的服务的开发.它结合了功能强大的软件堆栈和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02rO7B0.html" rel="bookmark">JMeter入门使用指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				初识JMeter 最近开始接触和使用JMeter进行性能测试,也是因为工作需要,不得不学习更多新技能,在此之前一直使用LR进行WEB系统的压力测试,但是在ZK开发的WEB系统,我选择使用JMeter. 主要是因为ZK脚本安全性在代码中产生的随机值太多,LR关联起来太麻烦.JMeter就不同了, ZK官方针对这个问题,专门为JMeter工具写了测试插件,所有生成的随机码(dtid.uuid)都能自动关联上.既然官方已有插件的支持,为何要盯着代码在LR中做体力活呢(还不一定有效果至少目前在网上能搜到			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38gdWK0.html" rel="bookmark">零基础入门学习java，应该如何快速打好Java基础？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				零基础入门学习java,应该如何快速打好Java基础?从大学到现在,我使用Java已经将近20年,日常也带实习生,还在公司内部做training,所以可以分享下我的经验,希望对你有用. 创一个小群,供大家学习交流聊天如果有对学java方面有什么疑惑问题的,或者有什么想说的想聊的大家可以一起交流学习一起进步呀.也希望大家对学java能够持之以恒java爱好群,如果你想要学好java最好加入一个组织,这样大家学习的话就比较方便,还能够共同交流和分享资料,给你推荐一个学习的组织:快乐学习java组织			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Yelar0.html" rel="bookmark">JMeter入门介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 概述 下载&amp;安装 实战JMetetr 测试计划简述 准备测试计划 编写测试计划 录制测试脚本 执行性能测试 单机测试 分布式测试 分析测试报告 APDEX 响应时间和吞吐量统计 测试结果详细报表 常用插件及扩展 Q&amp;A 概述 作为一名后端开发人员,熟练掌握一款性能测试工具非常有必要,这样有利于在技术选型时做一些参考. 常见的性能测试工具有:ab,JMeter,LoadRunner,他们都有各自的特点和应用场景: ab是Apache的一个工具组件,专门用于HTTP服务器测试. JMet			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDVNY0.html" rel="bookmark" class="title">mybatis基本操作（二）</a>
					<div>
						在这里&lt;mybatis基本操作(一)&gt;我介绍了mybatis使用配置文件对数据库进行增删改查.下面将介绍mybatis使用注解进行相应的操作.首先,使用注解同样要配置总配置文件,JavaB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqogE0.html" rel="bookmark" class="title">fastjson对Date的处理</a>
					<div>
						对日期的序列化: 一种方法是通过注解 Java代码   @JSONField (format=&quot;yyyy-MM-dd HH:mm:ss&quot;) public Date birthday ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8OeN0.html" rel="bookmark" class="title">linux下补丁制作及打补丁实例【转】</a>
					<div>
						转自:http://www.latelee.org/using-gnu-linux/diff-and-patch-on-linux.html 搞ARM有一段时日了,期间看了不少开发板的手册,手册的内容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6NZGrM.html" rel="bookmark" class="title">浏览器的重绘和重排（转）</a>
					<div>
						浏览器从下载文档到显示页面的过程是个复杂的过程,这里包含了重绘和重排.各家浏览器引擎的工作原理略有差别,但也有一定规则.简单讲,通常在文档初次加载时,浏览器引擎会解析HTML文档来构建DOM树,之后根 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35lqDv0.html" rel="bookmark" class="title">课堂练习&mdash;&mdash;计算法能够计算出读者购买一批书的最低价格。</a>
					<div>
						1.题目. 书店针对&lt;哈利波特&gt;系列书籍进行促销活动,一共5卷,用编号0.1.2.3.4表示, 单独一卷售价8元, 具体折扣如下所示:                          本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRq5k4.html" rel="bookmark" class="title">POJ 3187 Backward Digit Sums</a>
					<div>
						http://poj.org/problem?id=3187 穷竭搜索 全排列 然后按规则求和 排列之前先按升序排序 这样可以保证第一个和为k的就是符合最小序列的结果 1 #include &lt;i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5kaB3.html" rel="bookmark" class="title">【转】五分钟学会 Canvas 基础（一）</a>
					<div>
						原文:http://www.jianshu.com/p/d9ec1ef9c1e8 0.前言 最近忙里偷闲,来写的这篇文章,但是中午出去吃个饭,回来因为自己的误操作,把上午的文章全删除了,还没法找回.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGbep0.html" rel="bookmark" class="title">Core Data 数据操作 增删改查</a>
					<div>
						所有操作都基于Core Data框架相关 API,工程需要添加CoreData.framework支持 1.增  NSEntityDescription insertNewObjectForEntit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylZXm4.html" rel="bookmark" class="title">linux  history历史记录命令详解</a>
					<div>
						一.什么是history在bash功能中,它能记忆使用过的命令,这个功能最大的好处就是可以查询曾经做过的举动!从而可以知道你的运行步骤,那么就可以追踪你曾下达过的命令,以作为除错的工具! 二.Hist ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35wlpnM.html" rel="bookmark" class="title">http&colon;&sol;&sol;www&period;w3cschool&period;cc</a>
					<div>
						http://www.w3cschool.cc W3Cschoool菜鸟教程是一个提供最新的web技术站点,本站免费提供了建站相关的技术文档,帮助广大web技术爱好者快速入门并建立自己的网站.菜鸟先飞 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGR5Wy4.html" rel="bookmark" class="title">3--编译预处理</a>
					<div>
						一:预处理编译汇编连接过程 二 内置宏 条件编译 #if    #ifdef   #ifndef    #elif    #else  #endif #include #include &lt;fil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLeYK4.html" rel="bookmark" class="title">Java中transient有何作用？</a>
					<div>
						transient关键字用来防止序列化域.如果一个引用类型被transient修饰,则其反序列化的结果是null.基本类型则为0.如果引用类型时不可序列化的类,则也应该使用transient修饰,它在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47e5Po0.html" rel="bookmark" class="title">Java常量笔记</a>
					<div>
						在添加文件名的同时,文件名和内容可以不相同!! 1·Java 常量 常量就是固定不变的量,一旦被定义,它的值就不能被改变. 例实: 书中的代码不全,在这里不补充一下: 书中的源代码: public c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AaE7Z4.html" rel="bookmark" class="title">POJ 1573 &amp;amp&semi; POJ 2632（两道有趣的Robot）</a>
					<div>
						题目链接:POJ 1573 Robot Motion &amp; POJ 2632 Crashing Robots [题意]题意就不说了,有兴趣从链接点进去看吧,就是机器人各种打扫房间,行驶指令. [ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPpWbM.html" rel="bookmark" class="title">nfs服务安装部署测试</a>
					<div>
						nfs:网络文件系统作用:某个文件或目录共享,使其它用户可以通过网络访问此共享目录或文件.***特别注意共享的目录权限1.使用nfs需要先安装 yum install -y nfs-utils rpc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nepGXM.html" rel="bookmark" class="title">Python开发基础-Day14正则表达式和re模块</a>
					<div>
						正则表达式 就其本质而言,正则表达式(或 re)是一种小型的.高度专业化的编程语言,(在Python中)它内嵌在Python中,并通过 re 模块实现.正则表达式模式被编译成一系列的字节码,然后由用  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JjpQl4.html" rel="bookmark" class="title">linux-6的yum软件仓库</a>
					<div>
						yum命令 命令 作用 yum repolist all  列出所有仓库 yum list all  列出仓库中的所有软件包 yum  info 软件包名称  查看软件包信息 yum install  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLryZv3.html" rel="bookmark" class="title">JS try catch用法</a>
					<div>
						try{ //正常执行 }catch(e/*你感觉会出错的 错误类型*/){ // 可能出现的意外 eg:用户自己操作失误 或者 函数少条件 不影响下面的函数执行 // 有时也会用在 比如 focus ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDjQp73.html" rel="bookmark" class="title">玩转Java对象和XML相互转换</a>
					<div>
						最近在项目中一直出现Java对象和XML之间的相互转换,一开始由于项目很庞大,我又是临时调度过去,导致在按照项目组长的要求进行写代码的同时,总是在这块云里雾里,最近才慢慢开始搞清楚项目中具体的使用缘由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pg5Po3.html" rel="bookmark" class="title">pat1043&period; Is It a Binary Search Tree &lpar;25&rpar;</a>
					<div>
						1043. Is It a Binary Search Tree (25) 时间限制 400 ms 内存限制 65536 kB 代码长度限制 16000 B 判题程序 Standard 作者 CHEN ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
